#include <nds.h>
#include <fat.h>
#include <stdio.h>
#include <malloc.h>
#include <math.h>
	#include "screenshot.h"
	#include "protos.h"
	#include "floor_pcx.h"
	#include "wall_pcx.h"

#define VITESSE 2
#define MY_COS(n) COS[(n)]
#define MY_SIN(n) SIN[(n)]


typedef struct
{
	int sX;
	int sY;
	u8* map;
}map;


map carte;
int compteur=0,Vbl_compteur=0,FPS=0;
int32 posX = 0, posY = 0, angle = 90;
u16 cubeSize;
int	texture[2];
int faces;


int DrawGLScene();
void LoadWorld();
void Vbl_func()
{
	if(Vbl_compteur==60)
	{
		FPS=compteur;
		Vbl_compteur=0;
		compteur=0;
	}
	
	Vbl_compteur++;
}


int main()
{	
	// Turn on everything
	powerON(POWER_ALL);

	// Setup the Main screen for 3D 
	videoSetMode(MODE_0_3D);
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE);
	vramSetMainBanks(VRAM_A_TEXTURE, VRAM_B_TEXTURE, VRAM_C_SUB_BG, VRAM_D_LCD);
	
	// IRQ basic setup
	irqInit();
		irqSet(IRQ_VBLANK, Vbl_func);
		irqEnable(IRQ_VBLANK);
	
	SUB_BG0_CR = BG_MAP_BASE(31);
	BG_PALETTE_SUB[255] = RGB15(31,31,31);
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);

	// initialize the geometry engine
	glInit();
	
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ANTIALIAS);
	
	// setup the rear plane
	glClearColor(16,16,31,31); // BG must be opaque for AA to work
	glClearPolyID(63); // BG must have a unique polygon ID for AA to work
	glClearDepth(0x7FFF);

	// Set our viewport to be the same size as the screen
	glViewport(0,0,255,191);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspectivef32((70 * LUT_SIZE / 360), (256 / 192)<<12, 10, (2<<12));
	
	// Set the current matrix to be the model matrix
	glMatrixMode(GL_MODELVIEW);
	
	//ds specific, several attributes can be set here	
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_BACK | POLY_FORMAT_LIGHT0| POLY_FORMAT_LIGHT1| POLY_FORMAT_LIGHT2);
	
	fatInitDefault();
	
	LoadWorld();
	LoadGLTextures((u8*)floor_pcx, &texture[0]);
	LoadGLTextures((u8*)wall_pcx, &texture[1]);
	
	while (1) 
	{
		glColor3b(255, 255, 255);
		DrawGLScene();
		
		// flush to screen	
		glFlush(0);
		
		// wait for the screen to refresh
		swiWaitForVBlank();
			if(compteur == 0)
				iprintf("%d %d\n", FPS, faces);
			compteur++;
		
		scanKeys();
		if(keysDown() & KEY_START)
			screenshot("shot.bmp");
		
		if(keysHeld() & KEY_UP || keysHeld() & KEY_X)
		{
			posX += MY_COS(angle) / cubeSize;
			posY += MY_SIN(angle) / cubeSize;
		}
		if(keysHeld() & KEY_DOWN || keysHeld() & KEY_B)
		{
			posX -= MY_COS(angle) / cubeSize;
			posY -= MY_SIN(angle) / cubeSize;
		}
		if(keysHeld() & KEY_R || keysHeld() & KEY_RIGHT || keysHeld() & KEY_A)
		{
			angle += 4;
			if(angle >= 512)
				angle -= 512;
		}
		if(keysHeld() & KEY_L || keysHeld() & KEY_LEFT || keysHeld() & KEY_Y)
		{
			angle -= 4;
			if(angle <= 0)
				angle = 512 - angle;
		}
	}
	
	return 0;
}

int DrawGLScene()											// Here's Where We Do All The Drawing
{
	u8 x, y;
	v16 hauteur, fixedX, fixedY, xText, yText, hText, sDiv;
	faces = 0;
	
	hauteur = (carte.map[(posY / cubeSize) * carte.sX + (posX / cubeSize)] + 4) * cubeSize;
	
	glLoadIdentity();
	gluLookAtf32(	posX, hauteur, posY, //position 
					posX + MY_COS(angle), hauteur, posY + MY_SIN(angle), //objectif
					inttof32(0), inttof32(1), inttof32(0)); //verticale
	
	
	for(y = 0; y < carte.sY; y++)
	{
		for(x = 0; x < carte.sX; x++)
		{
			hauteur = carte.map[y * carte.sX + x] * cubeSize;
			fixedX = x * cubeSize;
			fixedY = y * cubeSize;
			
			
			if(hauteur < 14 * cubeSize)
			{
				glBindTexture(GL_TEXTURE_2D, texture[0]);
				
				sDiv = 2048 / 4;
				xText = sDiv * (x % 4);
				yText = sDiv * (y % 4);
				
				glBegin(GL_QUADS);
					glTexCoord2t16(xText, yText + sDiv);			glVertex3v16(fixedX,			hauteur,	fixedY + cubeSize);
					glTexCoord2t16(xText + sDiv, yText + sDiv);		glVertex3v16(fixedX + cubeSize,	hauteur,	fixedY + cubeSize);
					glTexCoord2t16(xText + sDiv, yText);			glVertex3v16(fixedX + cubeSize,	hauteur,	fixedY);
					glTexCoord2t16(xText, yText);					glVertex3v16(fixedX,			hauteur,	fixedY);
				glEnd();
				
				faces++;
			}
			
			if(hauteur > 0)
			{
				glBindTexture(GL_TEXTURE_2D, texture[1]);
				
				sDiv = 2048 / 4;
				xText = sDiv * (x % 4);
				yText = sDiv * (y % 4);
				hText = carte.map[y * carte.sX + x] * sDiv;
				
				glBegin(GL_QUADS);
					if(y > 0 && carte.map[(y - 1) * carte.sX + x] < carte.map[y * carte.sX + x])
					{
						glTexCoord2t16(xText, hText);			glVertex3v16(fixedX,			hauteur,	fixedY);
						glTexCoord2t16(xText + sDiv, hText);	glVertex3v16(fixedX + cubeSize,	hauteur,	fixedY);
						glTexCoord2t16(xText + sDiv, 0);		glVertex3v16(fixedX + cubeSize,	0,			fixedY);
						glTexCoord2t16(xText, 0);				glVertex3v16(fixedX,			0,			fixedY);
				
						faces++;
					}
					if(x > 0 && carte.map[y * carte.sX + (x - 1)] < carte.map[y * carte.sX + x])
					{
						glTexCoord2t16(yText + sDiv, hText);	glVertex3v16(fixedX,	hauteur,	fixedY + cubeSize);
						glTexCoord2t16(yText, hText);			glVertex3v16(fixedX,	hauteur,	fixedY);
						glTexCoord2t16(yText, 0);				glVertex3v16(fixedX,	0,			fixedY);
						glTexCoord2t16(yText + sDiv, 0);		glVertex3v16(fixedX,	0,			fixedY + cubeSize);
				
						faces++;
					}
					if(y < carte.sY - 1 && carte.map[(y + 1) * carte.sX + x] < carte.map[y * carte.sX + x])
					{
						glTexCoord2t16(xText + sDiv, hText);	glVertex3v16(fixedX + cubeSize,	hauteur,	fixedY + cubeSize);
						glTexCoord2t16(xText, hText);			glVertex3v16(fixedX,			hauteur,	fixedY + cubeSize);
						glTexCoord2t16(xText, 0);				glVertex3v16(fixedX,			0,			fixedY + cubeSize);
						glTexCoord2t16(xText + sDiv, 0);		glVertex3v16(fixedX + cubeSize,	0,			fixedY + cubeSize);
				
						faces++;
					}
					if(x < carte.sX - 1 && carte.map[y * carte.sX + (x + 1)] < carte.map[y * carte.sX + x])
					{
						glTexCoord2t16(yText, hText);			glVertex3v16(fixedX + cubeSize,	hauteur,	fixedY);
						glTexCoord2t16(yText + sDiv, hText);	glVertex3v16(fixedX + cubeSize,	hauteur,	fixedY + cubeSize);
						glTexCoord2t16(yText + sDiv, 0);		glVertex3v16(fixedX + cubeSize,	0,			fixedY + cubeSize);
						glTexCoord2t16(yText , 0);				glVertex3v16(fixedX + cubeSize,	0,			fixedY);
				
						faces++;
					}
				glEnd();
			}
		}
	}


return TRUE;
}


void LoadWorld()
{
	FILE* fichier = fopen("map.txt", "r");
	
		fread(&carte.sX, 1, 1, fichier);
		fread(&carte.sY, 1, 1, fichier);
		
		if(carte.sX > carte.sY)
			cubeSize = inttov16(1) / carte.sX;
		else
			cubeSize = inttov16(1) / carte.sY;
		
			carte.map = (u8*)malloc(carte.sX * carte.sY);
		
		fread(carte.map, 1, carte.sX * carte.sY, fichier);
	
	fclose(fichier);
}

