#include <nds.h>
#include <stdlib.h>
#include <stdio.h>

#include "screenshot.h"


void write16(u8* address, u16 value)
{
	address[0]=value&0xff;
	address[1]=value>>8;
}

void write32(u8* address, u32 value)
{
	address[0]=value&0xff;
	address[1]=(value>>8)&0xff;
	address[2]=(value>>16)&0xff;
	address[3]=(value>>24)&0xff;
}

void screenshot(const char* filename) {

	FILE* file=fopen(filename, "wb");

		REG_DISPCAPCNT=DCAP_BANK(3)|DCAP_ENABLE|DCAP_SIZE(3);
		while(REG_DISPCAPCNT & DCAP_ENABLE);

		u8 var16[2];
		u8 var32[4];

		write16(var16, 0x4D42); /* Magic identifier            */
			fwrite(var16, 1, 2, file);
		write32(var32, 256*192*3+sizeof(INFOHEADER)+sizeof(HEADER)); /* File size in bytes          */
			fwrite(var32, 1, 4, file);
		write16(var16, 0);
			fwrite(var16, 1, 2, file);
		write16(var16, 0);
			fwrite(var16, 1, 2, file);
		write32(var32, sizeof(INFOHEADER)+sizeof(HEADER)); /* Offset to image data, bytes */
			fwrite(var32, 1, 4, file);

		write32(var32, sizeof(INFOHEADER)); /* Header size in bytes      */
			fwrite(var32, 1, 4, file);
		write32(var32, 256); /* Width of image */
			fwrite(var32, 1, 4, file);
		write32(var32, 192); /* Height of image */
			fwrite(var32, 1, 4, file);
		write16(var16, 1); /* Number of colour planes   */
			fwrite(var16, 1, 2, file);
		write16(var16, 24); /* Bits per pixel            */
			fwrite(var16, 1, 2, file);
		write32(var32, 0); /* Compression type          */
			fwrite(var32, 1, 4, file);
		write32(var32, 256*192*3); /* Image size in bytes       */
			fwrite(var32, 1, 4, file);
		write32(var32, 0); /* Pixels per meter          */
			fwrite(var32, 1, 4, file);
		write32(var32, 0); /* Pixels per meter          */
			fwrite(var32, 1, 4, file);
		write32(var32, 0); /* Number of colours         */
			fwrite(var32, 1, 4, file);
		write32(var32, 0); /* Important colours         */
			fwrite(var32, 1, 4, file);

		for(int y=0;y<192;y++)
		{
			for(int x=0;x<256;x++)
			{
				u16 color=VRAM_D[256*192-y*256+x];

				u8 b=(color&31)<<3;
				u8 g=((color>>5)&31)<<3;
				u8 r=((color>>10)&31)<<3;

				fwrite(&r, 1, 1, file);
				fwrite(&g, 1, 1, file);
				fwrite(&b, 1, 1, file);
			}
		}

		DC_FlushAll();
	fclose(file);
}
